package Newick02;

use Exporter;
@ISA = (Exporter);
@EXPORT = qw(newick);
    
sub newick{

my $ref_nodes = shift;
my @nodes = @{$ref_nodes};
my $ref_nodes2 = shift;
my @nodes2 = @{$ref_nodes2};
my $ref_d_taxa2 = shift;
my @d_taxa2  = @{$ref_d_taxa2 };
my $ref_d_nodes = shift;
my @d_nodes = @{$ref_d_nodes};

my %node_dist = map { $nodes2[$_] => $d_nodes[$_] } 0..$#nodes2;

my $flg = 0;
my $sub = 0;
for (my $i=0;$i<=$#nodes;$i++){
    my $nnum = $#d_taxa2;
    for (my $j=0;$j<=$nnum;$j++){  
        my @ar1 = @{$d_taxa2[$j]}; 
        my $n1 = $#ar1;
        for (my $k=0;$k<=$n1;$k++){
            if ($nodes[$i] eq $d_taxa2[$j]->[$k]){
                $flg++;
                my @ar2 = @{$d_taxa2[$i-$sub]}; 
                my $n2 = $#ar2;
                my $nn = $n1+$n2;
                for (my $z1=0;$z1<=$k;$z1++){
                    $d_taxa2[$j]->[$z1] = $ar1[$z1];
                    if ($z1 == $k){
                        $d_taxa2[$j]->[$z1] = '(';
                        for (my $m=0;$m<=$n2;$m++){
                            $d_taxa2[$j]->[$z1+$m+1] = $d_taxa2[$i-$sub]->[$m];
                        }
                        $d_taxa2[$j]->[$z1+$n2+2] = ')'.$nodes[$i];
                    }
                }
                my $z3 = 0;
                for (my $z2=$k+$n2+2+1;$z2<=$nn+1+1;$z2++){
                    $d_taxa2[$j]->[$z2] = $ar1[$k+$z3+1];
                    $z3++;
                }
            }
        }
        
    }
    splice(@d_taxa2,$i-$sub,1) if ($flg>0 && $i<$#nodes);
    $sub++;
}


my $str;

$str .= "(";
foreach my $num (@d_taxa2){
my @ar3 = @{$num};
push @ar3, (')',')');

for (my $na=0; $na<$#ar3; $na++){
    if ( $ar3[$na] =~ /^\)(U\d)/){
        my $tmp = '):'.$node_dist{$1};
        my $out2 = $ar3[$na+1] =~ /\)/ ? $tmp : $tmp.','; ###########
        $str .= "$out2";
    }elsif($ar3[$na] =~ /^\w:/){
        my $out1 = $ar3[$na+1] =~ /\)/ ? $ar3[$na]:$ar3[$na].',';
        $str .= "$out1";
    }elsif($ar3[$na] =~ /\(/ || $ar3[$na] =~ /\)/){
        $str .= "$ar3[$na]";
    }
}

$str .= ";";
}
$str .= "\n\n";

return $str;

}

return 1;

__END__

